// Here's the source for Deepest Sender so far. It's the messiest, most rickety source on the planet coz I'm only just learning,
// but I'll clean it up the more I learn about how Mozilla works.
// Copyright David Murray 2002. All rights reserved, blah blah blah.

// Basically everything that looks messy, I wrote, and all the clean stuff with properly formatted variables are
// routines taken from Livelizard.

// Declaring nearly all my variables here so I don't get shafted by the scope of things...

const AppName = "Mozilla-DeepestSender/0.0.4";
var body, username, password, message, response, loggingin, posting, request, LJURL,
	postresponse, mood, music, security, groups, moodmenuindex,
	dontautoformat, backdate, removecomment, pickw, moodcount, usejournal;
var result = [];


loggingin = false;
posting = false;
groups = 0;
moodmenuindex = -1;

// Set up the login screen. Needs cleaning up.
function Init() {
	getPref().SetDefaultCharPref("deepestSender.LJURL", "www.livejournal.com");
	getPref().SetDefaultBoolPref("deepestSender.AutoLogin", false);
	getPref().SetDefaultBoolPref("deepestSender.SavePassword", false);
	getPref().SetDefaultCharPref("deepestSender.Moods", "");
	getPref().SetDefaultIntPref("deepestSender.LastMoodID", 0);
	getPref().SetDefaultCharPref("deepestSender.Security", "Public");
	getPref().SetDefaultBoolPref("deepestSender.DontAutoFormat", false);
	getPref().SetDefaultBoolPref("deepestSender.BackDate", false);
	getPref().SetDefaultBoolPref("deepestSender.RemoveComment", false);
	
	document.getElementById("server").value = getPref().CopyCharPref("deepestSender.LJURL");
	LJURL = "http://" + document.getElementById("server").value + "/interface/flat";
	document.getElementById("rememberpassword").checked = getPref().GetBoolPref("deepestSender.SavePassword");
	document.getElementById("autologin").checked = getPref().GetBoolPref("deepestSender.AutoLogin");
	OnOffAutoLogin(document.getElementById("rememberpassword"));
	moodcount = getPref().GetIntPref("deepestSender.LastMoodID");
	security = getPref().CopyCharPref("deepestSender.Security");
	dontautoformat = getPref().GetBoolPref("deepestSender.DontAutoFormat");
	backdate = getPref().GetBoolPref("deepestSender.BackDate");
	removecomment = getPref().GetBoolPref("deepestSender.RemoveComment");
	
	if (document.getElementById("rememberpassword").checked == true) {
		LoadCredentials();
		if (document.getElementById("autologin").checked == true) {
			Login();
		}
	}
}

// Sends off request to LiveJournal, all nice and asynchronous so it doesn't freeze up Mozilla.
function SendRequest(mode, URL, whattosend, ReadyStateFunction) {
	request = new XMLHttpRequest()
	request.onreadystatechange = ReadyStateFunction;
    request.open(mode, URL, true);
	request.send(whattosend);
}

// Just to enable/disable the auto-login button based on if saved password is clicked or not.
function OnOffAutoLogin(item) {
	if (item.checked) {
		document.getElementById("autologin").disabled = false;
	} else {
		document.getElementById("autologin").checked = false;
		document.getElementById("autologin").disabled = true;		
	}
}

// This gets done when a user pressed the login button, or it's set to auto-login.
function Login() {
	if (loggingin == false) {
		loggingin = true;
		document.getElementById("loginprogress").mode = "undetermined";
		username = document.getElementById("username").value;
		password = document.getElementById("password").value;
		document.getElementById("username").disabled = true;
		document.getElementById("password").disabled = true;
		document.getElementById("server").disabled = true;
		document.getElementById("rememberpassword").disabled = true;
		document.getElementById("autologin").disabled = true;
		document.getElementById("loginbutton").label = "Cancel";

		// Save password... This sorta gets messy with multiple users, still figuring it out...
		if (document.getElementById("rememberpassword").checked == false) { SaveCredentials(username,password,false); }
		
		body = "mode=login&user=" + escape(username) + "&hpassword=" + escape(hexMD5(password)) + "&clientversion=" + AppName;
		body += "&ver=1&getpickws=1&getpickwurls=1";
		body += "&getmoods=" + escape(moodcount);

		LJURL = "http://" + document.getElementById("server").value.trim() + "/interface/flat";
		response = SendRequest("POST", LJURL, body, SetUpMainBox);
	} else {
		request.abort();
		ResetBoxes();
	}
}

// Sends everything back to how it was when starting, or a post has successfully been made.
function ResetBoxes(clearall) {
	loggingin = false;
	posting = false;
	document.getElementById("loginprogress").mode = "determined";
	document.getElementById("username").disabled = false;
	document.getElementById("password").disabled = false;
	document.getElementById("server").disabled = false;
	document.getElementById("rememberpassword").disabled = false;
	OnOffAutoLogin(document.getElementById("rememberpassword"));
	document.getElementById("loginbutton").label = "Log In";
	document.getElementById("subject").disabled = false;
	document.getElementById("message").disabled = false;
	document.getElementById("postoptions").disabled = false;
	document.getElementById("postbutton").label = "Post";
	
	// So it doesn't wipe out your post if there's a problem sending it, this bit is here.
	if (clearall == true) {
		document.getElementById("subject").value = null;
		document.getElementById("message").value = null;
		dontautoformat = null;
		backdate = null;
		removecomment = null;
		security = "Public";
		mood = null;
		music = null;
		pickw = null;
	}
}

// Now it gets really icky... This is what happens when a login has been successful.
function SetUpMainBox() {
	if (request.readyState == 4) {
	response = request.responseText;

	document.getElementById("loginprogress").mode = "determined";
    if (getResponseData("success", response) == "OK") {
		
		// Getting a list of userpics and the URLs for them. These bits taken from Livelizard.
		result.pickw = [];
		for (i = 1; i <= getResponseData("pickw_count", response); i++) {
			result.pickw[i-1] = [];
			result.pickw[i-1].keyword = getResponseData("pickw_" + i, response);
			result.pickw[i-1].url = getResponseData("pickwurl_" + i, response);
		}

		// Find what journals the user has access to. From Livelizard.
		result.usejournal = [];
		for (i = 1; i <= getResponseData("access_count", response); i++) {
			result.usejournal[i-1] = getResponseData("access_" + i, response);
		}

		// Sort all the moods and everything - really messy so I stuck it in a separate function.
		GetMoods();
		usejournal = username;

		// Remembering passwords and automatic logging in.
		if (document.getElementById("rememberpassword").checked == true) {
			getPref().SetBoolPref("deepestSender.SavePassword", true);
			SaveCredentials(username, password, true);
			if (document.getElementById("autologin").checked == true) {
				getPref().SetBoolPref("deepestSender.AutoLogin", true);
			} else {
				getPref().SetBoolPref("deepestSender.AutoLogin", false);
			}
		} else {
			getPref().SetBoolPref("deepestSender.AutoLogin", false);
			getPref().SetBoolPref("deepestSender.SavePassword", false);
		}
		// Always save the last server used.
		getPref().SetCharPref("deepestSender.LJURL", document.getElementById("server").value.trim());
		document.getElementById("userpic").src = getResponseData("defaultpicurl", response);
		document.getElementById("usernametitle").value = username;
		document.getElementById("menubox").collapsed = false;
		document.getElementById("loginbox").collapsed = true;
		document.getElementById("mainbox").collapsed = false;
	} else if (getResponseData("success", response) == "FAIL") {
		// For if they've stuck their password in wrong or whatever.
		alert("Error connecting to LiveJournal.\n\n" + getResponseData("errmsg", response));
		ResetBoxes();
	} else if (getResponseData("success", response) == "") {
		// For if it's gotten a garbled reply or blank or whatnot.
		alert("Could not connect to the LiveJournal server.\n\nIt may be down, you\'re lagging too much, or your net connection is stuffed. Take your pick.");
		ResetBoxes();
	}
	} else {
		// For if the SendRequest status has changed stage but not hit 4 (completed) yet.
		return;
	}
}

// Duh.
function Logout() {
	username = null;
	password = null;
	message = null;
	response = null;
	postresponse = null;
	body = null;
	document.getElementById("menubox").collapsed = true;
	ResetBoxes(true);
	if (!document.getElementById("rememberpassword").checked) {
		document.getElementById("username").value = null;
		document.getElementById("password").value = null;
	}
	document.getElementById("userpic").src = "livejournal.gif";
	document.getElementById("loginbox").collapsed = false;
	document.getElementById("mainbox").collapsed = true;
}

// For when the Post button gets clicked.
function SendPost() {
	if (posting == false) {	
		// If it's not already in the process of posting, do this... (this is so the Post button can change to Cancel and stuff)
		posting = true;
		var now = new Date();
		var year = now.getYear() + 1900;
		var month = now.getMonth() + 1;
		var day = now.getDate();
		var hour = now.getHours();
		var min = now.getMinutes();

		subject = document.getElementById("subject").value;
		message = document.getElementById("message").value;
		// Make sure they've actually posted something before going along and doing everything.
		if (message.trim() == "") { posting = false; return; }
		body = "mode=postevent&user=" + escape(username) + "&hpassword=" + escape(hexMD5(password)) + "&event=" + escape(message);
		
		// Check if posting to a different journal.
	    if (username != usejournal) {
			body += "&usejournal=" + escape(usejournal);
		}
		
		if (subject) { body += "&subject=" + escape(subject); }
		
		// Ugh. The way LJ works is if you post a mood name instead of ID for one that it has on the server, it won't attach a funky little
		// pic to it. So that's what this whole mood ID thing is.
		if ((typeof(mood) == "number") && (mood > 0)) {
			body += "&prop_current_moodid=" + escape(mood);
		} else if (mood) {
			body += "&prop_current_mood=" + escape(mood);
		}
		// Find music.
		if (music) { body += "&prop_current_music=" + escape(music); }
		// Post security. I haven't figured out the code for enabling and disabling checkboxes all over the place on the Security Options page, so
		// groups doesn't work yet, only public/private/friends.
		if (security == "Friends") {
			body += "&security=usemask&allowmask=0";
		} else {
			body += "&security=" + escape(security.toLowerCase());
		}
		// For userpics!
		if (pickw) { body += "&prop_picture_keyword=" + escape(pickw); }
		
		if (dontautoformat) { body += "&prop_opt_preformatted=1"; }
		if (removecomment) { body += "&prop_opt_nocomments=1"; }
		if (backdate) { body += "&prop_opt_backdated=1"; }
		
		body += "&year=" + escape(year);
		body += "&mon=" + escape(month);
		body += "&day=" + escape(day);
		body += "&hour=" + escape(hour);
		body += "&min=" + escape(min);
		// Disable everything while its posting...
		document.getElementById("subject").disabled = true;
		document.getElementById("message").disabled = true;
		document.getElementById("postbutton").label = "Cancel";
		document.getElementById("postoptions").disabled = true;
		// Send off the request.
		response = SendRequest("POST", LJURL, body, Posting);
	} else {
		// In case they hit Cancel.
		request.abort();
		ResetBoxes();
	}
}

// This function runs when the request has been send off and it's waiting for a response from the server, same as SetUpMainBox().
function Posting() {
	if (request.readyState == 4) {
		postresponse = request.responseText;
	    if (getResponseData("success", postresponse) == "OK") {
			ResetBoxes(true);
		} else if (getResponseData("success", postresponse) == "FAIL") {
			alert("Error connecting to LiveJournal.\n\n" + getResponseData("errmsg", postresponse));
		} else if (getResponseData("success", postresponse) == "") {
			alert("Could not connect to the LiveJournal server.\n\nIt may be down, you\'re lagging too much, or your net connection is stuffed. Take your pick.");
		}
			ResetBoxes();
	} else {
		return;
	}
}

// Open post options window...
function PostOptionsWindow() {
	window.openDialog("chrome://deepestsender/content/PostOptions.xul","postoptions","chrome,modal,resizable");
}

// Open the Select Active Journal window. I'll combine these functions together eventually.
function SelectActiveJournal() {
	window.openDialog("chrome://deepestsender/content/SelectJournal.xul","selectjournal","chrome,modal");
}

// Whee, making a list of moods and caching them. Welcome to hell.
function GetMoods() {
	var i, j;
	var MoodsString = new String();
	// Gets the list of moods from a string in the preferences, in case they've already been saved. LJ works fine without doing all this,
	// and just having it get them on every login, but it makes it take longer to connect, so I put this stuff in.
	MoodsString = getPref().GetCharPref("deepestSender.Moods");
	result.moods = [];

	// Converts the string of moods into an array with their name and ID.
	if (MoodsString != "") {
		MoodArray = MoodsString.split(",");
		j = 0;
		for (i = 0; i < Math.ceil((MoodArray.length)/2); i++) {
			result.moods[i] = [];
			result.moods[i].id = MoodArray[j];
			result.moods[i].name = MoodArray[j+1];
			j = j + 2;
			
		}
	}

	// Gets and sorts the moods from the server... Shit I just think I found a bug.
	// Alright, sorted it I think... It had to do with the array indexes starting at 1 instead of 0... ruins the offseet of everything. I think I'll keep an eye
	// on it though; it seems to be working fine now, but needs more testing. Keeps chopping off the first mood in the list every now and again. Anyway, this gets
	// any moods off the server that weren't... Oh bloody hell. Found the problem. Right, now I think it's all good to go.
	
	if (parseInt(getResponseData("mood_count", response)) > 0) {
		j = result.moods.length;
		for (i = 1; i <= getResponseData("mood_count", response); i++) {
			result.moods[j] = [];
			result.moods[j].id = getResponseData("mood_" + i + "_id", response);
			result.moods[j].name = getResponseData("mood_" + i + "_name", response);
			j++;
		}
	}

	// This gets the list in alphabetical order.
	var temp;
	for (i = 0; i < result.moods.length; i++) {
		for (j = 0; j < result.moods.length -1; j++) {
			if (result.moods[j].name > result.moods[j+1].name) {
				temp = result.moods[j];
				result.moods[j] = result.moods[j+1];
				result.moods[j+1] = temp;
			}
		}
	}

	// Convert the array to a string and stick it back in the preferences.
	  MoodsString = "";

	for (i = 0; i < result.moods.length; i++) {
		MoodsString += result.moods[i].id + "," + result.moods[i].name + ",";
	}
	
	getPref().SetCharPref("deepestSender.Moods", MoodsString.slice(0,-1));
	getPref().SetIntPref("deepestSender.LastMoodID", result.moods.length + 2);
}

// For when the userpic is clicked, this opens the user's LJ. It opens it in the main window if its in the sidebar, or a new window if its running in its own.
// I want to make it so it opens it in window with the highest z-index under the Deepest Sender window but I dunno how yet.

function OpenJournalPage(extra) {
	var LJPage = "http://" + document.getElementById("server").value + "/users/" + username;
	if (extra) {
		LJPage += extra;
	}
	try{
	window._content.location.href = LJPage;
	} catch (e) {
		window.open(LJPage);
	}
}

function GetLocalTime(GMTtime) {
	// This is for what'll hopefully end up as a music detection thing once I figure out reading and writing to files. Not used yet, just in here so I don't
	// forget it.
	var GMTtime = GMTtime * 1000;
	var newDate = new Date(GMTtime);
	return newDate;
}